unit u_Distribuidor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DBCtrls, Buttons, ExtCtrls, DB, DBTables;

type
  TFDistribuidor = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    DBEdit10: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit1: TDBEdit;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    BitBtn2: TBitBtn;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FDistribuidor: TFDistribuidor;
  velho : integer;

implementation

uses u_DM;

{$R *.dfm}

function TFDistribuidor.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Distribuidor.db';
IndexFieldNames:='DisCodigo';
open;
if DataModule1.TDistribuidor.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TDistribuidor.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFDistribuidor.tabelavazia;
begin
if datamodule1.TDistribuidor.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
end;
end;

procedure TFDistribuidor.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;

procedure TFDistribuidor.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TDistribuidor.Last;
x := (DataModule1.TDistribuidor.FieldByName('DisCodigo').AsInteger + 1);
datamodule1.DSDistribuidor.AutoEdit:=true;
datamodule1.TDistribuidor.Insert;
DataModule1.TDistribuidor.FieldByName('DisCodigo').AsInteger := x;
dbedit1.setfocus;
botoes;
end;

procedure TFDistribuidor.editarClick(Sender: TObject);
begin
velho:=strtoint(dbedit1.text);
datamodule1.TDistribuidor.Edit;
datamodule1.DSDistribuidor.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
end;

procedure TFDistribuidor.deletarClick(Sender: TObject);
begin
DataModule1.TFilmes.IndexName := 'FilDistribuidor';
if DataModule1.TFilmes.FindKey([DataModule1.TDistribuidor.FieldByName('DisCodigo').asInteger]) then
begin
   ShowMessage('Distribuidor Vinculado na Tabela de Filmes');
end
else begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TDistribuidor.delete;
end;
tabelavazia;
end;
end;

procedure TFDistribuidor.cancelarClick(Sender: TObject);
begin
datamodule1.TDistribuidor.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFDistribuidor.gravarClick(Sender: TObject);
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  DataModule1.TDistribuidor.post;
  datamodule1.TDistribuidor.IndexFieldNames := '';
  DataModule1.DSDistribuidor.AutoEdit := false;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFDistribuidor.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFDistribuidor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
if (datamodule1.TDistribuidor.State= dsinsert) or (datamodule1.TDistribuidor.State = dsEdit)
then datamodule1.TDistribuidor.Cancel;

end;

procedure TFDistribuidor.FormShow(Sender: TObject);
begin
datamodule1.TDistribuidor.First;
datamodule1.DSDistribuidor.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
end;

end.
